{% from "shuup/front/macros/general.jinja" import render_field with context %}

{% macro render_vendor_filters_top() %}
    <div class="row product-list-actions">
        {# this is for map toggle #}
    </div>
    <div class="row vendor-list-actions vendor-wrap">
        <div class="col-md-6">
            <form role="form" method="get" action="" id="sorts_and_filters_1">
                {{ render_field(form.sort) }}
            </form>
        </div>
        <div class="col-md-6">
            <form role="form" method="get" action="" id="sorts_and_filters_2">
            {% if form.is_filter_available("categories") %}
                {{ render_field(form.categories) }}
            {% endif %}
            {% if form.is_filter_available("favorites_only") %}
                {{ render_field(form.favorites_only) }}
            {% endif %}
            </form>
        </div>
    </div>
{% endmacro %}

{% macro vendor_box(vendor, favorited) %}
    {% set u = url("shuup:supplier", pk=vendor.pk, slug=vendor.slug) %}
    <a href="{{ u }}" rel="vendor-detail" title="{{ vendor.name }}" class="brand-card" id="vendor-{{ vendor.id }}">
        <div class="image-wrap">
            {% if vendor.logo %}
                {% set image_url = vendor.logo|thumbnail(size=(500, 500), upscale=True) %}
            {% else %}
                {% set image_url = STATIC_URL ~ "shuup/front/img/no_image.png" %}
            {% endif %}
            <div class="image" style="background-image:url('{{ image_url }}')"></div>
            {% if render_favorite_button() %}
                {% from "shuup_multivendor/supplier/favorites_macro.jinja" import render_profile_favorite_button %}
                {{ render_profile_favorite_button(vendor.pk, favorited)}}
            {% endif %}
        </div>
        <div class="detail-wrap">
            <h2 class="name">
                {{ vendor.name }}
            </h2>
            {% if vendor.description %}
                <p class="text-muted">{{ vendor.description|truncatechars(175) }}</p>
            {% endif %}
            {{ render_vendor_review_rating(vendor) }}
        </div>
    </a>
{% endmacro %}

{% macro render_pagination(page, paginator, show_details=True) %}
    <script>
        window.PAGE_NUMBER = "{{ page.number }}";
    </script>
    <nav class="text-center">
        <ul class="pagination">
            {% if page.has_previous() %}
                <li id="previous_page">
                    <a href="#"
                       onclick="refreshVendorFilters({{ page.previous_page_number()}}); return false;"
                       aria-label="{% trans %}Previous{% endtrans %}">
                        <i class="fa fa-angle-left"></i>
                    </a>
                </li>
            {% else %}
                <li id="previous_page" class="disabled">
                    <span aria-label="{% trans %}Previous{% endtrans %}">
                        <i class="fa fa-angle-left" aria-hidden="true"></i>
                    </span>
                </li>
            {% endif %}
            {% for i in page_range or paginator.page_range %}
                <li id="pagination_page_{{ i }}" class="{% if i == page.number %}active{% endif %}">
                    <a href="#" onclick="refreshVendorFilters({{ i }}); return false;">{{ i }}</a>
                </li>
            {% endfor %}
            {% if page.has_next() %}
                <li id="next_page">
                    <a href="#"
                       onclick="refreshVendorFilters({{ page.next_page_number() }}); return false;"
                       aria-label="{% trans %}Next{% endtrans %}">
                        <i class="fa fa-angle-right"></i>
                    </a>
                </li>
            {% else %}
                <li id="next_page" class="disabled">
                    <span aria-label="{% trans %}Next{% endtrans %}">
                        <i class="fa fa-angle-right" aria-hidden="true"></i>
                    </span>
                </li>
            {% endif %}
        </ul>
        {% if show_details %}
            <p class="text-muted">
                {{ gettext("Items %(start_index)d of %(end_index)d of %(count)d total", start_index=page.start_index(), end_index=page.end_index(), count=paginator.count) }}
            <p>
        {% endif %}
    </nav>
{% endmacro %}

{% macro render_vendor_list() %}
    <div id="ajax_vendor_content">
        <div class="vendor-list-view">
            {% set favorite_vendor_ids = get_favorite_vendor_ids(page_obj) if render_favorite_button() else [] %}
            {% for vendor in page_obj %}
                <div class="single-vendor">
                    {{ vendor_box(vendor, favorited=vendor.id in favorite_vendor_ids) }}
                </div>
            {% endfor %}
        </div>
        <div class="clearfix">
            {{ render_pagination(page_obj, page_obj.paginator) }}
        </div>
    </div>
{% endmacro %}

{% if request.is_ajax() %}
    {%- import "shuup/front/macros/general.jinja" as macros with context -%}
    {{ render_vendor_list() }}
{% else %}
    {% extends "shuup/front/base.jinja" %}
    {% block title %}{{ _("Brands") }}{% endblock %}

    {% block breadcrumb %}
        {% call macros.breadcrumb() %}
            {{ macros.render_breadcrumb_item("/", _("Home")) }}
            {{ macros.render_breadcrumb_item(None, _("Brands"), True) }}
        {% endcall %}
    {% endblock %}

    {% block content %}
        <h1>
            {{ _("Brands") }}
        </h1>
        {% placeholder "vendor_top" %}{% endplaceholder %}
        <script>window.VENDOR_LIST_FILTERS = {{ form.fields.keys()|list|json }};</script>

        {{ render_vendor_filters_top() }}
        {{ render_vendor_list() }}

        {% placeholder "vendor_bottom" %}{% endplaceholder %}
    {% endblock %}

    {% block extrajs %}
        <link rel="stylesheet" href="{{ shuup_static('shuup_multivendor/vendor-list.css', 'shuup-multivendor') }}">
        <script src="{{ shuup_static('shuup_multivendor/vendor.js', 'shuup-multivendor') }}"></script>
    {% endblock %}
{% endif %}
